; bracket.lsp

(load "jpnslisp.lsp")

(defmacro push (x y)
    `(setq ,y (cons ,x ,y)) )

(defmacro pop (y)
    `(cond
	((null ,y) nil)
	(t
	 (prog1
	    (car ,y)
	    (setq ,y (cdr ,y)) ) ) ) )

(setq *getc-empty* t)

(setq *getc-eof* nil)

(setq *getc-buf* nil)

(defun getc (fp)
    (let ((l) (ch))
	(cond
	    ((and *getc-eof* (null *getc-buf*)) (setq *getc-empty* t) (setq *getc-eof* nil) (setq *getc-buf* nil) -1)
	    (*getc-eof*
	     (setq ch (car *getc-buf*))
	     (setq *getc-buf* (cdr *getc-buf*))
	     ch )
	    (*getc-empty*
	     (setq l (multiple-value-list (read-line fp)))
	     (setq *getc-empty* nil)
	     (setq *getc-eof* (cadr l))
	     (setq *getc-buf* (coerce (car l) 'list))
	     (cond
		((and *getc-eof* (null *getc-buf*)) (setq *getc-empty* t) 0)
		(*getc-eof*
		 (setq ch (car *getc-buf*))
		 (setq *getc-buf* (cdr *getc-buf*))
		 ch )
		((null *getc-buf*) (setq *getc-empty* t) 0)
		(t
		 (setq ch (car *getc-buf*))
		 (setq *getc-buf* (cdr *getc-buf*))
		 ch ) ) )
	    ((null *getc-buf*) (setq *getc-empty* t) 0)
	    (t
	     (setq ch (car *getc-buf*))
	     (setq *getc-buf* (cdr *getc-buf*))
	     ch ) ) ) )

(defun bracket ()
    (let ((fname) (in-fname) (out-fname) (in-fp) (out-fp))
	(princ "X[p[ʃRo[^ version1.00 by rr") (terpri)
	(setq fname (get-fname))
	(setq in-fname (make-in-fname fname))
	(setq out-fname (make-out-fname fname))
	(setq in-fp (open in-fname))
	(cond
	    ((null in-fp) (princ in-fname) (princ "J܂B") (terpri))
	    (t
		(setq out-fp (open out-fname :direction :output))
		(cond
		    ((null out-fp) (princ out-fname) (princ "J܂B") (terpri))
		    (t
			(princ in-fname) (princ "ǂݍł܂...") (terpri)
			(princ out-fname) (princ "nĂ܂...") (terpri)
			(main in-fp out-fp)
			(close in-fp)
			(close out-fp) ) ) ) ) ) )

(defun get-fname ()
    (let ((name) (rname) (r-name))
	(loop
	    (princ "Ro[gt@Cigq.braj͂ĉ:")
	    (setq name (read-line))
	    (cond
		((string-equal name "") nil)
		(t
		 (setq rname (reverse (coerce name 'list)))
		 (setq r-name rname)
		 (setq pos 0)
		 (loop
		    (cond
			((null rname) (progn (setq pos -1) (return nil)))
			((equal (car rname) #\.)
			 (return t) )
			(t
			 (setq rname (cdr rname))
			 (setq pos (1+ pos)) ) ) )
		 (cond
		    ((= pos -1) (return name))
		    ((string-equal (subseq (coerce r-name 'string) 0 pos) "arb")
		     (return (reverse (subseq (coerce r-name 'string) (1+ pos)))) )
		    (t (return name)) ) ) ) ) ) )

(defun make-in-fname (fname)
    (coerce (append (coerce fname 'list) '(#\. #\b #\r #\a)) 'string) )

(defun make-out-fname (fname)
    (coerce (append (coerce fname 'list) '(#\. #\l #\s #\p)) 'string) )

(setq *stack* nil)

(defun main (in out)
    (let ((flag))
	(loop
	    (setq flag (write-1st-bracket in out))
	    (cond
		((= flag -1) (return t))
		((= flag -2)
		 (princ ".") )
		((= flag 1)
		 (princ "]̐܂B") (terpri)
		 (return nil) )
		((= flag 2)
		 (princ ")̐܂B") (terpri)
		 (return nil) )
		((= flag 3)
		 (princ "]̐܂B") (terpri)
		 (return nil) )
		((= flag 4)
		 (princ "񂪈ُłB") (terpri) (return nil) ) ) ) ) )

(setq *para1* nil)

(setq *para2* nil)

(setq *para3* nil)

(defun getch (fp)
    (setq *para1* *para2*)
    (setq *para2* *para3*)
    (setq *para3* (getc fp)) )

(defun is-char ()
    (and (equal *para1* #\#) (equal *para2* #\\) ) )

(defun is-char2 () (equal *para2* #\\))

(defun write-1st-bracket (in out)
    (let ((ch) (flag) (n))
	(loop
	    (setq ch (getch in))
	    (cond
		((equal ch -1) (return (if (null (setq n (pop *stack*))) -1 (progn (push n *stack*) 1))))
		((equal ch 0) (terpri out))
		((and (equal ch #\;) (not (is-char)))
		 (princ ch out)
		 (if (= 2 (setq flag (loop
		    (setq ch (getch in))
		    (if (equal ch -1) (return (if (null (setq n (pop *stack*))) -1 (progn (push n *stack*) 1))))
		    (if (equal ch 0) (progn (terpri out) (return 2)))
		    (princ ch out) ) ) ) 2 (return flag) ) )
		((and (equal ch #\") (not (is-char2)))
		 (princ ch out)
		 (if (= 0 (setq flag (loop
		    (setq ch (getch in))
		    (if (equal ch -1) (return 4))
		    (if (equal ch 0) (return 4))
		    (if (and (equal ch #\") (not (is-char2))) (progn (princ ch out) (return 0)))
		    (princ ch out) ) ) ) 0 (return flag) ) )
		((and (equal ch #\() (not (is-char)))
		 (princ ch out)
		 (push 1 *stack*)
		 (if (= 0 (setq flag (write-bracket in out))) 0 (return flag)) )
		((and (equal ch #\[) (not (is-char)))
		 (princ #\( out)
		 (push 1 *stack*)
		 (if (= 0 (setq flag (write-bracket in out))) 0 (return flag)) )
		(t (princ ch out)) ) ) ) )

(defun write-bracket (in out)
    (let ((ch) (flag) (n) (k))
	(loop
	    (setq ch (getch in))
	    (cond
		((equal ch -1) (return (if (null (setq n (pop *stack*))) -1 (progn (push n *stack*) 1))))
		((equal ch 0) (terpri out))
		((and (equal ch #\;) (not (is-char)))
		 (princ ch out)
		 (if (= 2 (setq flag (loop
		    (setq ch (getch in))
		    (if (equal ch -1) (return (if (null (setq n (pop *stack*))) -1 (progn (push n *stack*) 1))))
		    (if (equal ch 0) (progn (terpri out) (return 2)))
		    (princ ch out) ) ) ) 2 (return flag) ) )
		((and (equal ch #\") (not (is-char2)))
		 (princ ch out)
		 (if (= 0 (setq flag (loop
		    (setq ch (getch in))
		    (if (equal ch -1) (return 4))
		    (if (equal ch 0) (return 4))
		    (if (and (equal ch #\") (not (is-char2))) (progn (princ ch out) (return 0)))
		    (princ ch out) ) ) ) 0 (return flag) ) )
		((and (equal ch #\() (not (is-char)))
		 (princ ch out)
		 (push (1+ (pop *stack*)) *stack*)
		 (if (= 0 (setq flag (write-bracket in out))) 0 (return flag)) )
		((and (equal ch #\[) (not (is-char)))
		 (princ #\( out)
		 (push 1 *stack*)
		 (if (= 0 (setq flag (write-bracket in out))) 0 (return flag)) )
		((and (equal ch #\)) (not (is-char)))
		 (princ ch out)
		 (setq n (1- (pop *stack*)))
		 (cond
		    ((= n 0) (setq k (pop *stack*)) (if (not (null k)) (push k *stack*))
		     (if (null k) (return -2) (return 0)) )
		    (t (push n *stack*)) ) )
		((and (equal ch #\]) (not (is-char)))
		 (setq n (pop *stack*))
		 (loop
		    (if (= n 0) (return))
		    (princ #\) out)
		    (setq n (1- n)) )
		 (setq k (pop *stack*)) (if (not (null k)) (push k *stack*)) (if (null k) (return -2) (return 0)) )
		(t (princ ch out)) ) ) ) )


(bracket)
